package com.gic.cloud.data.hook.api.entity;

import com.gic.cloud.data.hook.api.dto.QueryDataType;
import com.google.common.collect.Lists;

import java.util.List;

/** 自助指标查询下载任务容器
 * @author Sam
 */
public class FlatQueryTaskCondition {

	/** 关联的下载任务编号 */
	protected String taskId = "";

	/** 关联的下载任务编号
	 * @return
	 */
	public String getTaskId() {
		return taskId;
	}

	/** 关联的下载任务编号
	 * @param taskId
	 */
	public void setTaskId(String taskId) {
		this.taskId = taskId;
	}

	/** 关联表名 */
	protected String tableId = "";

	/** 关联表名
	 * @return
	 */
	public String getTableId() {
		return tableId;
	}

	/** 关联表名
	 * @param tableId
	 */
	public void setTableId(String tableId) {
		this.tableId = tableId;
	}

	/** 请求数据类型 */
	protected Integer queryDataType = QueryDataType.SAFE;

	/** 请求数据类型
	 * @return
	 */
	public Integer getQueryDataType() {
		return queryDataType;
	}

	/** 请求数据类型
	 * @param queryDataType
	 */
	public void setQueryDataType(Integer queryDataType) {
		this.queryDataType = queryDataType;
	}

	/** 关联的企业编号集合 */
	protected List<String> enterpriseIds = Lists.newArrayList();

	/** 关联的企业编号集合
	 * @return
	 */
	public List<String> getEnterpriseIds() {
		return enterpriseIds;
	}

	/** 关联的企业编号集合
	 * @param enterpriseIds
	 */
	public void setEnterpriseIds(List<String> enterpriseIds) {
		this.enterpriseIds = enterpriseIds;
	}

	/** 关联查询条件 */
	protected List<FlatQueryCondition> conditions = null;

	/** 关联查询条件
	 * @return
	 */
	public List<FlatQueryCondition> getConditions() {
		return conditions;
	}

	/** 关联查询条件
	 * @param conditions
	 */
	public void setConditions(List<FlatQueryCondition> conditions) {
		this.conditions = conditions;
	}

	/** 获取解密过滤字段集合
	 * @return
	 */
	public List<String> getDecryptFilters() {
		List<String> results = Lists.newArrayList();
		if (this.conditions != null && this.conditions.size() > 0) {
			for (FlatQueryCondition condition : this.conditions) {
				if (condition.getEnableEncrypt()) results.add(condition.getFieldMark());
			} // FOR OVER
		} // IF OVER
		return results;
	}

	/** 排序字段指定 */
	protected String orderField = "";

	/** 排序字段指定
	 * @return
	 */
	public String getOrderField() {
		return orderField;
	}

	/** 排序字段指定
	 * @param orderField
	 */
	public void setOrderField(String orderField) {
		this.orderField = orderField;
	}

	/** 排序方向指定 */
	protected String orderDir = "";

	/** 排序方向指定
	 * @return
	 */
	public String getOrderDir() {
		return orderDir;
	}

	/** 排序方向指定
	 * @param orderDir
	 */
	public void setOrderDir(String orderDir) {
		this.orderDir = orderDir;
	}

	/** 是否进行 DISTINCT */
	protected Boolean execDistinct = false;

	/** 是否进行 DISTINCT
	 * @return
	 */
	public Boolean getExecDistinct() {
		return execDistinct;
	}

	/** 是否进行 DISTINCT
	 * @param execDistinct
	 */
	public void setExecDistinct(Boolean execDistinct) {
		this.execDistinct = execDistinct;
	}

	/** 允许构建 */
	protected String buildPermitted = Global.NO;

	/** 允许构建
	 * @return
	 */
	public String getBuildPermitted() {
		return buildPermitted;
	}

	/** 允许构建
	 * @param buildPermitted
	 */
	public void setBuildPermitted(String buildPermitted) {
		this.buildPermitted = buildPermitted;
	}


	private List<String> authStoreIdList;

	public List<String> getAuthStoreIdList() {
		return authStoreIdList;
	}

	public void setAuthStoreIdList(List<String> authStoreIdList) {
		this.authStoreIdList = authStoreIdList;
	}
}
